<template>
  <RequestCertificatePage
    ref="requestCertificatePage"
    certificate-type="personal"
    :certificate-request-body-getter="getCertificateRequestBody"
    :start-over-extra-steps="startOverExtraSteps"
  >
    <v-checkbox
      v-model="requestCertificatePage.request.emailAddresses"
      :value="store.user?.primaryEmail"
      :label="store.user?.primaryEmail"
      :disabled="true"
      hide-details
    ></v-checkbox>
    <v-checkbox
      v-for="(email, idx) in store.user?.auxiliaryEmails"
      :key="idx"
      v-model="requestCertificatePage.request.emailAddresses"
      :value="email"
      :label="email"
      hide-details
    ></v-checkbox>
  </RequestCertificatePage>
</template>

<script lang="ts">
import { defineComponent, Ref, ref } from "vue";
import RequestCertificatePage, {
  RequestCertificatePageData,
  RequestCertificateSubPage,
} from "@/components/RequestCertificatePage.vue";
import { requestBackend, store } from "@/ts/common";
import { Identification, IdentificationType } from "@/ts/types";
import { APIError } from "@/ts/errorTypes";

export default defineComponent({
  components: { RequestCertificatePage },
  setup() {
    return {
      store,
      requestCertificatePage: ref() as Ref<RequestCertificatePageData>,
    };
  },
  mounted() {
    this.loadIdentification();
  },
  methods: {
    loadIdentification: function () {
      requestBackend<Array<IdentificationType>>(`/identifications`).then(
        (data) => {
          // This is just a guard for typescript and should never happen
          if (!this.store.user) {
            return;
          }

          if (data.length === 0) {
            // No data received, show "missing identification" error page
            this.requestCertificatePage.error = null;
            this.requestCertificatePage.subPage = RequestCertificateSubPage.Error;
            return;
          }

          this.requestCertificatePage.request.identification = new Identification(data[0]);
          this.requestCertificatePage.request.primaryEmailAddress = this.store.user.primaryEmail;
          this.requestCertificatePage.request.emailAddresses = [
            this.store.user.primaryEmail,
            ...this.store.user.auxiliaryEmails,
          ];

          this.requestCertificatePage.subPage = RequestCertificateSubPage.Request;
        },
        (error: APIError) => {
          this.requestCertificatePage.request.identification = null;
          this.requestCertificatePage.error = error;
          this.requestCertificatePage.subPage = RequestCertificateSubPage.Error;
        }
      );
    },
    startOverExtraSteps: function () {
      this.requestCertificatePage.request.identification = null;
      this.loadIdentification();
    },
    getCertificateRequestBody: function () {
      return {
        emails: this.requestCertificatePage.request.emailAddresses,
        identification_id: this.requestCertificatePage.request.identification?.publicId,
      };
    },
  },
});
</script>
